<!DOCTYPE HTML>
<html xmlns:layout="http://www.w3.org/1999/xhtml" layout:decorate="~{layout/main}">
<head>
    <title>Bull-EzyVolt</title>
    <script src="/js/gauge.js"></script>
    <style type="text/css">
	.myCalss{
		margin-left: -160px;
	}
</style>
</head>
<body>
<div layout:fragment="content">
    <nav class="navbar navbar-expand-lg navbar-transparent  bg-primary  navbar-absolute">
        <div class="container-fluid">
            <div class="navbar-wrapper">
                <div class="navbar-toggle">
                    <button type="button" class="navbar-toggler">
                        <span class="navbar-toggler-bar bar1"></span>
                        <span class="navbar-toggler-bar bar2"></span>
                        <span class="navbar-toggler-bar bar3"></span>
                    </button>
                </div>
                <a class="navbar-brand" href="#pablo">Current Productivity</a>
            </div>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navigation" aria-controls="navigation-index" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-bar navbar-kebab"></span>
                <span class="navbar-toggler-bar navbar-kebab"></span>
                <span class="navbar-toggler-bar navbar-kebab"></span>
            </button>
           <!-- <div class="collapse navbar-collapse justify-content-end" id="navigation">
                <form>
                    <div class="input-group no-border">
                        <input type="text" value="" class="form-control" placeholder="Search...">
                        <div class="input-group-append">
                            <div class="input-group-text">
                                <i class="fa fa-search fa-sm"></i>
                            </div>
                        </div>
                    </div>
                </form>
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="#pablo">
                            <i class="fa fa-user fa-lg"></i>
                            <p>
                                <span class="d-lg-none d-md-block">Account</span>
                            </p>
                        </a>
                    </li>
                </ul>
            </div>-->
        </div>
    </nav>

    <div class="panel-header panel-header-lg">
        <canvas id="bigDashboardChart"></canvas>
    </div>
    <div class="content">
        <div class="row">
            <div class="col-lg-6 col-md-6">
                <div class="card card-chart">
                    <div class="card-header">
                        <h5 class="card-category"></h5>
                        <h4 class="card-title">Weekly Availability Performance</h4>
                    </div>
                    <div class="card-body">
                        <div class="chart-area">
                            <canvas id="barChartSimpleGradientsNumbers"></canvas>
                        </div>
                    </div>
                    <div class="card-footer">
                        <div class="stats">
                            <i class="fa fa-clock fa-lg"></i> Last 7 days
                        </div>
                    </div>
                </div>
            </div>

            <div class="col-lg-6 col-md-6">
                <div class="card card-chart">
                    <div class="card-header">
                        <h5 class="card-category"></h5>
                        <h4 class="card-title">Weekly productive Performance</h4>
                    </div>
                    <div class="card-body">
                        <div class="chart-area">
                            <canvas id="weeklyProductiveChart"></canvas>
                        </div>
                    </div>
                    <div class="card-footer">
                        <div class="stats">
                            <i class="fa fa-clock fa-lg"></i> Last 7 days
                        </div>
                    </div>
                </div>
            </div>
        </div>

    <div class="row">



        <div class="col-lg-12 col-md-6">
            <div class="card card-chart">
                <div class="card-header">
                    <h5 class="card-category"></h5>
                    <h4 class="card-title">Current Consumption</h4>
                    <div class="dropdown">

                    </div>
                </div>
                <div class="card-body">
                    <div class="chart-area" id="machineReadings" style='margin-right: 20px';>
                        <canvas id="gauge1"></canvas>
                        <span class="myCalss">Machine 1</span>
                        <canvas id="gauge2"></canvas>
                        <span class="myCalss">Machine 1</span>
                    </div>
                </div>
                <div class="card-footer">
                    <div class="stats">
                        <i class="fa fa-sync-alt fa-lg"></i> Just Updated
                    </div>
                </div>
            </div>
        </div>

    </div>

</div>
    <script>
        $(document).ready(function() {
          // Javascript method's body can be found in assets/js/demos.js


              var opts = {
      angle: 0, // The span of the gauge arc
      lineWidth: 0.1, // The line thickness
      radiusScale: 0.50, // Relative radius
      pointer: {
        length: 0.46, // // Relative to gauge radius
        strokeWidth: 0.029, // The thickness
        color: '#000000' // Fill color
      },
      limitMax: false,     // If false, max value increases automatically if value > maxValue
      limitMin: false,     // If true, the min value of the gauge will be fixed
      colorStart: '#778899',   // Colors
      colorStop: '#2F4F4F',    // just experiment with them
      strokeColor: '#FF7F50',  // to see which ones work best for you
      generateGradient: true,
      highDpiSupport: true,     // High resolution support
      staticLabels: {
      font: "10px sans-serif",  // Specifies font
      labels: [1,2],  // Print labels at these values
      color: "#000000",  // Optional: Label text color
      fractionDigits: 0  // Optional: Numerical precision. 0=round off.
        },


      };

    var machines=[];

     $.ajax({
                                 contentType: "application/json;charset=UTF-8",
                                 url: "/api/v1/machines",
                                 dataType: "json",
                                 type: "GET",
                                 async:false,
                                 success:function(data){
                                    var machineStr="";
                                    for(var i=0;i<data.length;i++){

                                    machines.push(data[i].mcid);

                                     machineStr=machineStr+" <canvas id='"+machines[i]+"'></canvas>";
                                     machineStr=machineStr+"<span class='myCalss'>"+machines[i]+"</span>";
                                    }
                                    $("#machineReadings").html(machineStr);




                                 }

                                 });


    var gauges=[];
    for(var m=0;m<machines.length;m++){

      var machindId=$('#'+machines[m]);
      var target=document.getElementById(machines[m]);
       var gauge = new Gauge(target).setOptions(opts); // create sexy gauge!
       gauge.maxValue = 2; // set max gauge value
       gauge.minValue=0;  // Prefer setter over gauge.minValue = 0
       gauge.animationSpeed = 9; // set animation speed (32 is default value)
       gauges.push(gauge);
       gauge.set(getMachineLive(machines[m]));




    }

    setInterval(function(){

	for(var m=0;m<machines.length;m++){
		var gaugeObj=gauges[m];

		gaugeObj.set(getMachineLive(machines[m]));
	}
	},
	2000);



     //getMachineLive function starts

        function getMachineLive(machineId){

                var machineReading=0;
                 $.ajax({
                                         contentType: "application/json;charset=UTF-8",
                                         url: "api/v1/live/reading/"+machineId,
                                         dataType: "json",
                                         type: "GET",
                                         async:false,
                                         success:function(data){

                                                if(data!=''){
                                                machineReading=data;
                                            }
                                           }
                 });
                 return machineReading;

        }

     // getMachineLive function ends


     //Hourly metrics starts

     //colors
   var  chartColors = [
	 'CD0303',//red
	 'F18A06',//oragnce
     'E7E113',//yellow
     '53E713',//green
	 '13D4E7',//blue
	 'AD13E7',//purple
	 '565C5F'//grey
    ];

     //get Dates

     var hourlyObj={
                    maintainAspectRatio: false,
                    legend: {
                      display: true
                    },
                    tooltips: {
                      bodySpacing: 4,
                      mode: "nearest",
                      intersect: 0,
                      position: "nearest",
                      xPadding: 10,
                      yPadding: 10,
                      caretPadding: 10
                    },
                    responsive: 1,
                    scales: {
                      yAxes: [{
                       scaleLabel: {
                            display: true,
                            labelString: 'Consumption In Amps'
                       },
                        gridLines: 0,
                        gridLines: {
                          zeroLineColor: "transparent",
                          drawBorder: false
                        }
                      }],
                      xAxes: [{

                        gridLines: {
                          zeroLineColor: "transparent",
                          drawTicks: false,
                          display: true,
                          drawBorder: false

                        }
                      }]
                    },
                    layout: {
                      padding: {
                        left: 0,
                        right: 0,
                        top: 15,
                        bottom: 15
                      }
                    }
                  };
         var e = document.getElementById("barChartSimpleGradientsNumbers").getContext("2d");



      showHourlyMetrics();

      function showHourlyMetrics(){

              $.ajax({
                    contentType: "application/json;charset=UTF-8",
                    url: "/api/v1/live/metrics/hourly",
                    dataType: "json",
                    type: "GET",
                    async:false,
                    success:function(data){
                    hourlyMetrics(data);
                    }
            });

      }












        function hourlyMetrics(dateMetrics){

         var barChartData = {
                            labels: [],
                            datasets: []
            };
        var lablesData=[];
            for(var i=0;i<dateMetrics.length;i++){
                var machinId=dateMetrics[i].mchine.mcid;
                var colorId=chartColors[i];
                var gadient = e.createLinearGradient(0, 170, 0, 50);
                gadient.addColorStop(0, '#'+colorId);
                gadient.addColorStop(1, '#'+colorId);
                var metrics=dateMetrics[i].metrics;
                 var dataVaues=[];


                for(var m=0;m<metrics.length;m++){
                    var dataItem=metrics[m];

                        if(i==0){

                           var dtObj=new Date(dataItem.datetime);
                           var lablStr=dtObj.getDate().toString()+"/"+(dtObj.getMonth()+1).toString();

                           lablesData.push(lablStr);
                       }
                     //dataset

                     dataVaues.push(metrics[m].value);

                }

                var dataSet={
                      label: ""+machinId,
                      borderColor: "#"+colorId,
                      pointBorderColor: "#FFF",
                      pointBackgroundColor: "#18ce0f",
                      pointBorderWidth: 2,
                      pointHoverRadius: 4,
                      pointHoverBorderWidth: 1,
                      pointRadius: 4,
                      fill: true,
                      backgroundColor: gadient,
                      borderWidth: 2,
                      data: dataVaues
                    }

                   barChartData.datasets.push(dataSet);

            }
            barChartData.labels=lablesData;
            var viewsChart = new Chart(e, {
				type: 'bar',
				data: barChartData,
				options:hourlyObj
            });

        }


 var productiveObj={
                    maintainAspectRatio: false,
                    legend: {
                      display: true
                    },
                    tooltips: {
                      bodySpacing: 4,
                      mode: "nearest",
                      intersect: 0,
                      position: "nearest",
                      xPadding: 10,
                      yPadding: 10,
                      caretPadding: 10
                    },
                    responsive: 1,
                    scales: {
                      yAxes: [{
                       scaleLabel: {
                            display: true,
                            labelString: 'Coil used In centimeter'
                       },
                        gridLines: 0,
                        gridLines: {
                          zeroLineColor: "transparent",
                          drawBorder: false
                        }
                      }],
                      xAxes: [{

                        gridLines: {
                          zeroLineColor: "transparent",
                          drawTicks: false,
                          display: true,
                          drawBorder: false

                        }
                      }]
                    },
                    layout: {
                      padding: {
                        left: 0,
                        right: 0,
                        top: 15,
                        bottom: 15
                      }
                    }
                  };
        var prodChart=document.getElementById("weeklyProductiveChart").getContext("2d");
        showProductiveMetrics();




      function showProductiveMetrics(){

              $.ajax({
                    contentType: "application/json;charset=UTF-8",
                    url: "/api/v1/live/metrics/productive",
                    dataType: "json",
                    type: "GET",
                    async:false,
                    success:function(data){
                    productiveMetrics(data);
                    }
            });

      }


         function productiveMetrics(dateMetrics){

         var barChartData = {
                            labels: [],
                            datasets: []
            };
        var lablesData=[];
            for(var i=0;i<dateMetrics.length;i++){
                var machinId=dateMetrics[i].mchine.mcid;
                var colorId=chartColors[i];
                var gadient = prodChart.createLinearGradient(0, 170, 0, 50);
                gadient.addColorStop(0, '#'+colorId);
                gadient.addColorStop(1, '#'+colorId);
                var metrics=dateMetrics[i].metrics;
                 var dataVaues=[];


                for(var m=0;m<metrics.length;m++){
                    var dataItem=metrics[m];

                        if(i==0){

                           var dtObj=new Date(dataItem.datetime);
                           var lablStr=dtObj.getDate().toString()+"/"+(dtObj.getMonth()+1).toString();

                           lablesData.push(lablStr);
                       }
                     //dataset

                     dataVaues.push(metrics[m].value);

                }

                var dataSet={
                      label: ""+machinId,
                      borderColor: "#"+colorId,
                      pointBorderColor: "#FFF",
                      pointBackgroundColor: "#18ce0f",
                      pointBorderWidth: 2,
                      pointHoverRadius: 4,
                      pointHoverBorderWidth: 1,
                      pointRadius: 4,
                      fill: true,
                      backgroundColor: gadient,
                      borderWidth: 2,
                      data: dataVaues
                    }

                   barChartData.datasets.push(dataSet);

            }
            barChartData.labels=lablesData;
            var viewsChart = new Chart(prodChart, {
				type: 'bar',
				data: barChartData,
				options:productiveObj
            });

        }











       /**
        barChartData.datasets.push(newDataSet);

       **/



     //hourly metrics ends



     //Live chart starts
 var chartColor = "#FFFFFF";
      var ctx2 = document.getElementById('bigDashboardChart').getContext("2d");

    var gradientStroke = ctx2.createLinearGradient(500, 0, 100, 0);
    gradientStroke.addColorStop(0, '#80b6f4');
    gradientStroke.addColorStop(1, chartColor);

    var gradientFill = ctx2.createLinearGradient(0, 200, 0, 50);
    gradientFill.addColorStop(0, "rgba(128, 182, 244, 0)");
    gradientFill.addColorStop(1, "rgba(255, 255, 255, 0.24)");



    var labelData=[];

    var dateValues=[];
    var dateObjs=[];

    getLiveData()


    var timSLots=[0,9,18,27,36,45,54,59]
    function drawLive(){

    var curentDate=new Date();

        for(var i=0;i<60;i++){
        labelData[i]="";
        }

         for(var i=0;i<timSLots.length;i++){

            var dateVal=new Date(dateObjs[timSLots[i]]);

            var timTxt=""+dateVal.getMinutes();
            if(timTxt.length==1 ){
                timTxt="0"+timTxt;
            }
            labelData[timSLots[i]]=dateVal.getHours()+":"+timTxt;
            // dateValues[i]=0;
        }





        var live = {
                  type: 'line',
                  data: {
                    labels: labelData,
                    datasets: [{
                      label: "Data",
                      borderColor: chartColor,
                      pointBorderColor: chartColor,
                      pointBackgroundColor: "#1e3d60",
                      pointHoverBackgroundColor: "#1e3d60",
                      pointHoverBorderColor: chartColor,
                      pointBorderWidth: 1,
                      pointHoverRadius: 5,
                      pointHoverBorderWidth: 2,
                      pointRadius: 3,
                      fill: true,
                      backgroundColor: gradientFill,
                      borderWidth: 2,
                      data: dateValues
                    }]
                  },
                  options: {
                    layout: {
                      padding: {
                        left: 20,
                        right: 20,
                        top: 0,
                        bottom: 0
                      }
                    },
                    maintainAspectRatio: false,
                    tooltips: {
                      backgroundColor: '#fff',
                      titleFontColor: '#333',
                      bodyFontColor: '#666',
                      bodySpacing: 4,
                      xPadding: 12,
                      mode: "nearest",
                      intersect: 0,
                      position: "nearest"
                    },
                    legend: {
                      position: "bottom",
                      fillStyle: "#FFF",
                      display: false
                    },
                    scales: {
                      yAxes: [{
                        ticks: {
                          fontColor: "rgba(255,255,255,0.4)",
                          fontStyle: "bold",
                          beginAtZero: true,
                          maxTicksLimit: 5,
                          padding: 10
                        },
                        gridLines: {
                          drawTicks: true,
                          drawBorder: false,
                          display: true,
                          color: "rgba(255,255,255,0.1)",
                          zeroLineColor: "transparent"
                        }

                      }],
                      xAxes: [{
                        gridLines: {
                          zeroLineColor: "transparent",
                          display: false,

                        },
                        ticks: {
                          padding: 10,
                          fontColor: "rgba(255,255,255,0.4)",
                          fontStyle: "bold"
                        }
                      }]
                    }
                  }
                };

                var liveChart = new Chart(ctx2, live);
        }

    function getLiveData(){

                    $.ajax({
                                 contentType: "application/json;charset=UTF-8",
                                 url: "/api/v1/live/",
                                 dataType: "json",
                                 type: "GET",
                                 success:function(data){

                                    for(i=0;i<data.length;i++){
                                        dateValues[i]=data[i].count;
                                        dateObjs[i]=data[i].dateTime;
                                    }

                                    drawLive();


                                 }

                                 });
    }



    setInterval(function(){
           getLiveData();

        }, 100000);


     // Live chart ends

    });
  </script>
</div>
</body>